#!/usr/bin/php
<?php
	//email library
	include("Net/IMAPProtocol.php"); 
	include("Net/IMAP.php");

	//festival / CMU voices
	$voices=array("kal_diphone", "ked_diphone", "cmu_us_awb_arctic_hts", "cmu_us_bdl_arctic_hts", "cmu_us_jmk_arctic_hts", "cmu_us_slt_arctic_hts");
	$voice_counter=0;
	
	$asterisk_outbound="/var/spool/asterisk/outgoing/";
	//$asterisk_outbound="/Users/chris/Desktop/";	//for local testing
	$sable_file="sable/friday_%%COUNTER.sable";
	
	//lyrics and templates
	//read lyrics
	$friday_lyrics = readTextFile("assets/friday_lyrics.txt");
	//read sable template
	$sable_template = readTextFile("assets/friday_template.sable");
	//read call file template
	$call_file_template = readTextFile("assets/friday_template.call");
	
	//text2wave command line
	$audio_dir="/home/ck987/telefriday";
	$text2wave="text2wave -F 8000 -o %%WAV_FILE %%SABLE_FILE";

	//google info
	//google voice phone number
	$gv_phone_number="1413xxxxxxx"; //replace with your phone number
	//Gmail Settings
	$mailbox_username = "xxxx@gmail.com"; //replace with your account
	$mailbox_password = "xxxx";  //replace with your password
	$mailbox_hostname = "ssl://imap.gmail.com";
	$mailbox_port = 993; // SSL
	$print_output = true;
	
	//******* FUNCTIONS ****************
	// returns true if $str begins with $sub
	function beginsWith( $str, $sub ) {
    	return ( substr( $str, 0, strlen( $sub ) ) == $sub );
	}
	//read in and return the contents of a text file
	function readTextFile($filePath){
			//read lyrics
		$fh = fopen($filePath, 'r');
		$text = fread($fh, filesize($filePath));
		fclose($fh);
		return $text;
	}
	
	//writes a file, and gives the option to set permissions
	function writeTextFile($filePath, $text, $permissions=0999){
		$fh = fopen($filePath, 'w') or die("can't open file");
		fwrite($fh, $text);
		fclose($fh);
		if ($permissions != 0999){
			chmod($filePath, $permissions);
		}
	}
	
	function generateCall($counter, $text, $phone_number){
		global $text2wave, $asterisk_outbound, $voices, $call_file_template;
		global $sable_template, $sable_file, $tokens, $audio_dir, $print_output;
		//replace voice_name token with first voice, and replace text token with text.
		$vcount = $counter;
		if ($vcount >= count($voices)){
			$vcount = 0;
		}
		$sable = str_replace(array("%%VOICE_NAME", "%%TEXT"), array($voices[$vcount],$text), $sable_template);
		if ($print_output) echo $sable;  //debugging
		$sable_file_output=str_replace("%%COUNTER",$counter,$sable_file);
		writeTextFile($sable_file_output, $sable, 0755);
		//make file paths
		echo("counter = $counter \n");
		$asterisk_file_path="$audio_dir/friday_$counter";
		$wav_file_path="$asterisk_file_path.wav";
		//generate audio wav file
		$text2wave_cmd= str_replace(array("%%WAV_FILE", "%%SABLE_FILE"), array($wav_file_path,$sable_file_output),$text2wave);
		//use text2wave to generate audio file
		exec($text2wave_cmd);
		//replace call file tokens
		$call_file = str_replace(array("%%PHONE_NUMBER","%%WAV_FILE"), array($phone_number, $asterisk_file_path), $call_file_template);
		if ($print_output) echo($call_file);
		$call_file_name="friday_$counter.call";
		writeTextFile($call_file_name, $call_file, 0777);
		rename($call_file_name, $asterisk_outbound.$call_file_name);
	}
	
	//strip out the google voice transcript
	function transcript($rawBody){
		$begin=strpos($rawBody, "Transcript:");
		$end=strpos($rawBody,"Play message:");
		//echo($begin."  ".$end."\n");
		if($begin >0 && $end > 0) {
			$retStr = substr($rawBody,$begin+12, $end-$begin-12);
		} else {
			$retStr = $rawBody;
		}
		return $retStr;
	
	}
	//****** CODE ****************
	
	//generate original voice file
	generateCall($voice_counter, $friday_lyrics, $gv_phone_number);
	$voice_counter++; //use next voice
	//check every 60 seconds for a new transcript
	while($voice_counter < count($voices)){
		sleep(60);
	// Create a IMAP Object
	$imap = &new Net_IMAP();
			// Connect to the mail box
	if ($imap->connect($mailbox_hostname, $mailbox_port)) {
		// Tell the user we are connected
		if ($print_output) {
			echo "Connected to $mailbox_hostname\n";
		}
		
		// Log in to the mail box
		if ($imap->login($mailbox_username, $mailbox_password)) {
			// Tell the user we are logged in
			if ($print_output) {
				echo "Logged in to $mailbox_hostname\n";
			}
		
			// Go through the messages
			// Messages start at index 1
			for ($i = 1; $i <= $imap->numMsg(); $i++) {
							// Check if new message
				$newMessage = $imap->isSeen($i);
								//echo ($newMessage."\n");
				// If they are allowed, keep going
				if (!$newMessage) {
					// Tell the user which message we are on
					if ($print_output) {
						echo "Message number: $i\n";
					}
					// Tell the user we have an unseen message
					if ($print_output) {
						echo "Message $i is unseen\n";
					}
					// Get the message itself
					$message_text = transcript($imap->getBody($i));
					if ($print_output) echo "body: $message_text\n";
					if ($message_text != "") {
						//make sure that the transcription doesn't say "transcript not available" or "Unable to transcribe"
						if (!beginsWith($message_text, "Unable to") && !beginsWith($message_text, "Transcript not")){
							if ($print_output) echo "message is legit\n";
							//generate next voice file
							generateCall($voice_counter, $message_text, $gv_phone_number);
							$voice_counter++;
						}
					}
				}
			}
		}
	}
}
?>